/*
* Copyright dylhoxic
*
* dylhoxic _at_ tuxfamily _dot_ org
*
* This software is a first person shooter game.
*
* This software is governed by the CeCILL version 2 license under French law and
* abiding by the rules of distribution of free software.  You can  use, 
* modify and/ or redistribute the software under the terms of the CeCILL
* license as circulated by CEA, CNRS and INRIA at the following URL
* "http://www.cecill.info". 
*
* As a counterpart to the access to the source code and rights to copy,
* modify and redistribute granted by the license, users are provided only
* with a limited warranty  and the software's author,  the holder of the
* economic rights,  and the successive licensors  have only  limited
* liability. 
*
* In this respect, the user's attention is drawn to the risks associated
* with loading,  using,  modifying and/or developing or reproducing the
* software by the user in light of its specific status of free software,
* that may mean  that it is complicated to manipulate,  and  that  also
* therefore means  that it is reserved for developers  and  experienced
* professionals having in-depth computer knowledge. Users are therefore
* encouraged to load and test the software's suitability as regards their
* requirements in conditions enabling the security of their systems and/or 
* data to be ensured and,  more generally, to use and operate it in the 
* same conditions as regards security. 
*
* The fact that you are presently reading this means that you have had
* knowledge of the CeCILL version 2 license and that you accept its terms.
*/

/*! \file collision.c
 * \brief collision functions
 */

#include "collision.h"

/* test if a point is inside a poly */
SDL_bool ray_in_tri2( GLfloat *tris, vec_t *pos, Uint32 tri_idx )
{
	vec_t vec1, vec2, vec3;
	GLfloat angle, vec1_norm, vec2_norm, vec3_norm;

	vec1.x = tris[ tri_idx ] - pos->x;
	vec1.y = tris[ tri_idx+1 ] - pos->y;
	vec1.z = tris[ tri_idx+2 ] - pos->z;
	
	/* tri_idx++; */

	vec2.x = tris[ tri_idx+3 ] - pos->x;
	vec2.y = tris[ tri_idx+4 ] - pos->y;
	vec2.z = tris[ tri_idx+5 ] - pos->z;

	/* tri_idx++; */

	vec3.x = tris[ tri_idx+6 ] - pos->x;
	vec3.y = tris[ tri_idx+7 ] - pos->y;
	vec3.z = tris[ tri_idx+8 ] - pos->z;
	
	vec1_norm = vec_get_norm( &vec1 );
	vec2_norm = vec_get_norm( &vec2 );
	vec3_norm = vec_get_norm( &vec3 );
	
	angle = acos( vec_dotprod( &vec1, &vec2 ) / ( vec1_norm * vec2_norm ));
	angle += acos( vec_dotprod( &vec2, &vec3 ) / ( vec2_norm * vec3_norm ));
	angle += acos( vec_dotprod( &vec3, &vec1 ) / ( vec3_norm * vec1_norm ));

	if( angle > (0.99f * 2.0f * M_PI ) )
		return SDL_TRUE;
	else
		return SDL_FALSE;
}

