/*
* Copyright dylhoxic
*
* dylhoxic _at_ tuxfamily _dot_ org
*
* This software is a first person shooter game.
*
* This software is governed by the CeCILL version 2 license under French law and
* abiding by the rules of distribution of free software.  You can  use, 
* modify and/ or redistribute the software under the terms of the CeCILL
* license as circulated by CEA, CNRS and INRIA at the following URL
* "http://www.cecill.info". 
*
* As a counterpart to the access to the source code and rights to copy,
* modify and redistribute granted by the license, users are provided only
* with a limited warranty  and the software's author,  the holder of the
* economic rights,  and the successive licensors  have only  limited
* liability. 
*
* In this respect, the user's attention is drawn to the risks associated
* with loading,  using,  modifying and/or developing or reproducing the
* software by the user in light of its specific status of free software,
* that may mean  that it is complicated to manipulate,  and  that  also
* therefore means  that it is reserved for developers  and  experienced
* professionals having in-depth computer knowledge. Users are therefore
* encouraged to load and test the software's suitability as regards their
* requirements in conditions enabling the security of their systems and/or 
* data to be ensured and,  more generally, to use and operate it in the 
* same conditions as regards security. 
*
* The fact that you are presently reading this means that you have had
* knowledge of the CeCILL version 2 license and that you accept its terms.
*/

/*! \file events.c
 * \brief events functions
 */

#include "events.h"

/* proto */
void handle_key_up( SDL_keysym* keysym );
void handle_key_down( SDL_keysym* keysym );

void process_events( void ) 
{
	SDL_Event event;

    	while( SDL_PollEvent( &event ) ) 
	{
		switch( event.type ) 
		{
        		case SDL_KEYUP:
				handle_key_up( &event.key.keysym );
            			break;
			case SDL_KEYDOWN:
            			handle_key_down( &event.key.keysym );
            			break;
			case SDL_QUIT:
				handle_exit();
            			break;
        	}

    	}	
}

void handle_key_down( SDL_keysym* keysym )
{
	switch( keysym->sym ) 
	{
		case SDLK_UP:
			hkw_ig->cam_cur->motion = 1.0f;
			break;
		case SDLK_DOWN:
			hkw_ig->cam_cur->motion = -1.0f;
			break;
		case SDLK_a:
			hkw_ig->mesh_ig[2]->nact++;	
			hkw_ig->mesh_ig[2]->act[ hkw_ig->mesh_ig[2]->nact - 1 ] = 0;
			break;
		case SDLK_s:
			hkw_ig->mesh_ig[2]->nact++;	
			hkw_ig->mesh_ig[2]->act[ hkw_ig->mesh_ig[2]->nact - 1 ] = 1;
			break;
		case SDLK_ESCAPE:
			handle_exit();
			break;
		default:
			break;
	}

}

void handle_key_up( SDL_keysym* keysym )
{
	switch( keysym->sym ) {
		case SDLK_UP:
			if( hkw_ig->cam_cur->motion > 0.0f)
				hkw_ig->cam_cur->motion = 0.0f;
			break;
		case SDLK_DOWN:
			if( hkw_ig->cam_cur->motion < 0.0f)
				hkw_ig->cam_cur->motion = 0.0f;
			break;
		case SDLK_a:
			if( hkw_ig->mesh_ig[2]->nact == 0)
				hkw_ig->mesh_ig[2]->cur_frame[ 0 ] = 0;
			else
				hkw_ig->mesh_ig[2]->cur_frame[ hkw_ig->mesh_ig[2]->nact - 1 ] = 0;
			hkw_ig->mesh_ig[2]->nact = 0;	
			break;
		case SDLK_s:
			if( hkw_ig->mesh_ig[2]->nact == 0)
				hkw_ig->mesh_ig[2]->cur_frame[ 0 ] = 0;
			else
				hkw_ig->mesh_ig[2]->cur_frame[ hkw_ig->mesh_ig[2]->nact - 1 ] = 0;
			hkw_ig->mesh_ig[2]->nact = 0;
			break;
		default:
			break;
	}
}

void handle_exit() 
{
	ig_free();
	
	if(SDL_WasInit(SDL_INIT_EVERYTHING))	
		SDL_Quit();

	SDL_Delay(2000);

	exit(0);
}
