/*
* Copyright dylhoxic
*
* dylhoxic _at_ tuxfamily _dot_ org
*
* This software is a first person shooter game.
*
* This software is governed by the CeCILL version 2 license under French law and
* abiding by the rules of distribution of free software.  You can  use, 
* modify and/ or redistribute the software under the terms of the CeCILL
* license as circulated by CEA, CNRS and INRIA at the following URL
* "http://www.cecill.info". 
*
* As a counterpart to the access to the source code and rights to copy,
* modify and redistribute granted by the license, users are provided only
* with a limited warranty  and the software's author,  the holder of the
* economic rights,  and the successive licensors  have only  limited
* liability. 
*
* In this respect, the user's attention is drawn to the risks associated
* with loading,  using,  modifying and/or developing or reproducing the
* software by the user in light of its specific status of free software,
* that may mean  that it is complicated to manipulate,  and  that  also
* therefore means  that it is reserved for developers  and  experienced
* professionals having in-depth computer knowledge. Users are therefore
* encouraged to load and test the software's suitability as regards their
* requirements in conditions enabling the security of their systems and/or 
* data to be ensured and,  more generally, to use and operate it in the 
* same conditions as regards security. 
*
* The fact that you are presently reading this means that you have had
* knowledge of the CeCILL version 2 license and that you accept its terms.
*/

/*! \file ingame.h
 * \brief 'in game' header
 *
 * define a new type ingame_t
 */

#ifndef __defined_ingame_h
#define __defined_ingame_h

#include <stdlib.h>
#include <stdio.h>

#include <SDL.h>

#include "camera.h"
#include "mesh.h"
#include "map.h"
#include "portal.h"

/*! \brief ingame structure */
typedef struct ingame_s
{
	/* screen infos */
	int width;
	int height;
	
	Uint32 bpp;
	/* current camera in use in the game */
	camera_t *cam_cur;
	
	map_t *map;
	spg_t *spg;

	/* */
	Uint32 fps;
	Uint32 nmesh;
	amesh_ig_t **mesh_ig;
}ingame_t;

/* proto */
Uint32 ig_init(Uint32 nmesh);
void ig_free();

/*! \brief
 * hkw_ig is a global var used in the game to access different useful values or objects
 * such as, for instance, screen width, camera, maps, .... 
 */
ingame_t *hkw_ig;

#endif
