/*
* Copyright dylhoxic
*
* dylhoxic _at_ tuxfamily _dot_ org
*
* This software is a first person shooter game.
*
* This software is governed by the CeCILL version 2 license under French law and
* abiding by the rules of distribution of free software.  You can  use, 
* modify and/ or redistribute the software under the terms of the CeCILL
* license as circulated by CEA, CNRS and INRIA at the following URL
* "http://www.cecill.info". 
*
* As a counterpart to the access to the source code and rights to copy,
* modify and redistribute granted by the license, users are provided only
* with a limited warranty  and the software's author,  the holder of the
* economic rights,  and the successive licensors  have only  limited
* liability. 
*
* In this respect, the user's attention is drawn to the risks associated
* with loading,  using,  modifying and/or developing or reproducing the
* software by the user in light of its specific status of free software,
* that may mean  that it is complicated to manipulate,  and  that  also
* therefore means  that it is reserved for developers  and  experienced
* professionals having in-depth computer knowledge. Users are therefore
* encouraged to load and test the software's suitability as regards their
* requirements in conditions enabling the security of their systems and/or 
* data to be ensured and,  more generally, to use and operate it in the 
* same conditions as regards security. 
*
* The fact that you are presently reading this means that you have had
* knowledge of the CeCILL version 2 license and that you accept its terms.
*/

/*! \file map.h
 * \brief map header
 *
 * define a new type for map object : map_t
 */

#ifndef __defined_map_h
#define __defined_map_h

#include <stdlib.h>
#include <stdio.h>

#include <SDL.h>

#include "c_util.h"
#include "light.h"
#include "mesh.h"

/* define */
#define HKW_MAP_L1 "Hekaw map"
#define HKW_MAP_L1L 9
#define HKW_MAP_NBO 'm'

#define HKW_MAP_MAXL 5

/*! \brief map structure */
typedef struct map_s
{
	Uint32 nsmesh, nlight;
	char **meshname;
	amesh_t **smesh;
	char **lightname;
	light_t **light;
}map_t;

map_t *map_init(Uint32 nb_smesh, Uint32 nb_light);
void map_free(map_t *map);
void map_display(map_t *map);
map_t *map_load(char *filename);

void light_selection(map_t *map);

#endif
