/*
* Copyright dylhoxic
*
* dylhoxic _at_ tuxfamily _dot_ org
*
* This software is a first person shooter game.
*
* This software is governed by the CeCILL version 2 license under French law and
* abiding by the rules of distribution of free software.  You can  use, 
* modify and/ or redistribute the software under the terms of the CeCILL
* license as circulated by CEA, CNRS and INRIA at the following URL
* "http://www.cecill.info". 
*
* As a counterpart to the access to the source code and rights to copy,
* modify and redistribute granted by the license, users are provided only
* with a limited warranty  and the software's author,  the holder of the
* economic rights,  and the successive licensors  have only  limited
* liability. 
*
* In this respect, the user's attention is drawn to the risks associated
* with loading,  using,  modifying and/or developing or reproducing the
* software by the user in light of its specific status of free software,
* that may mean  that it is complicated to manipulate,  and  that  also
* therefore means  that it is reserved for developers  and  experienced
* professionals having in-depth computer knowledge. Users are therefore
* encouraged to load and test the software's suitability as regards their
* requirements in conditions enabling the security of their systems and/or 
* data to be ensured and,  more generally, to use and operate it in the 
* same conditions as regards security. 
*
* The fact that you are presently reading this means that you have had
* knowledge of the CeCILL version 2 license and that you accept its terms.
*/

/*! \file plane.c
 * \brief plane functions
 */

#include "plane.h"

GLfloat plane_dist( plane_t *plane, vec_t *vec)
{
	return -plane->pcst + vec_dotprod( &(plane->nvec), vec);
}

SDL_bool ray_plane( vec_t *start, vec_t *end, plane_t *plane, vec_t *intersection )
{
	vec_t dir;
	/* vec_t l1; */
	/* float linelenght; */
	GLfloat t1;
	float denom;

	dir.x = end->x - start->x;
	dir.y = end->y - start->y;
	dir.z = end->z - start->z;

	denom = vec_dotprod( &plane->nvec, &dir );
	/* vec_normalize( &denom ); */

	if( (denom > -0.01f) && (denom < 0.01f) )
	{
		return SDL_FALSE;
	}

	t1 = ( (plane->pcst) - vec_dotprod( start, &(plane->nvec)) ) / denom ;

	/*
	if( (t1 >= 0.0f) && (t1 <= 1.0f) )
	{
		l1.x = -( start->x + (t1 * dir->x ) );
		l1.y = -( start->y + (t1 * dir->y ) );
		l1.z = -( start->z + (t1 * dir->z ) );
	}
	*/
	intersection->x = - ( start->x + (t1 * dir.x) );
	intersection->y = - ( start->y + (t1 * dir.y) );
	intersection->z = - ( start->z + (t1 * dir.z) );
	
	
	/* return l1; */
	return SDL_TRUE;
}
