/*
* Copyright dylhoxic
*
* dylhoxic _at_ tuxfamily _dot_ org
*
* This software is a first person shooter game.
*
* This software is governed by the CeCILL version 2 license under French law and
* abiding by the rules of distribution of free software.  You can  use, 
* modify and/ or redistribute the software under the terms of the CeCILL
* license as circulated by CEA, CNRS and INRIA at the following URL
* "http://www.cecill.info". 
*
* As a counterpart to the access to the source code and rights to copy,
* modify and redistribute granted by the license, users are provided only
* with a limited warranty  and the software's author,  the holder of the
* economic rights,  and the successive licensors  have only  limited
* liability. 
*
* In this respect, the user's attention is drawn to the risks associated
* with loading,  using,  modifying and/or developing or reproducing the
* software by the user in light of its specific status of free software,
* that may mean  that it is complicated to manipulate,  and  that  also
* therefore means  that it is reserved for developers  and  experienced
* professionals having in-depth computer knowledge. Users are therefore
* encouraged to load and test the software's suitability as regards their
* requirements in conditions enabling the security of their systems and/or 
* data to be ensured and,  more generally, to use and operate it in the 
* same conditions as regards security. 
*
* The fact that you are presently reading this means that you have had
* knowledge of the CeCILL version 2 license and that you accept its terms.
*/

/*! \file shader.h
 * \brief shader header
 */

#ifndef __defined_shader_h
#define __defined_shader_h

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <SDL.h>
#include <SDL_opengl.h>

#include "c_util.h"
#include "extensions.h"
#include "debug.h"

/* defines */
/* not defined at least on SDL 1.9 headers */
#ifndef GL_SHADING_LANGUAGE_VERSION_ARB
#define GL_SHADING_LANGUAGE_VERSION_ARB 0x8B8C
#endif

#define GLSL_MAX_SIZE 3072

/*! \brief structure for glsl structure */
typedef struct sh_glsl_s
{
	GLhandleARB program;
	GLhandleARB vertex_shader;
	GLhandleARB fragment_shader;
}sh_glsl_t;

/* proto */
GLboolean shader_init();
char *shader_from_file(char *filename);
GLboolean shader_create(sh_glsl_t *shader, char *vs_filename, char *fs_filename);
void shader_free(sh_glsl_t *shader);
GLboolean shader_compile(GLhandleARB *program, GLhandleARB *shader, GLenum shader_type, char *filename);
void shader_get_log(GLhandleARB *obj);

#endif

