/*
* Copyright dylhoxic
*
* dylhoxic _at_ tuxfamily _dot_ org
*
* This software is a first person shooter game.
*
* This software is governed by the CeCILL version 2 license under French law and
* abiding by the rules of distribution of free software.  You can  use, 
* modify and/ or redistribute the software under the terms of the CeCILL
* license as circulated by CEA, CNRS and INRIA at the following URL
* "http://www.cecill.info". 
*
* As a counterpart to the access to the source code and rights to copy,
* modify and redistribute granted by the license, users are provided only
* with a limited warranty  and the software's author,  the holder of the
* economic rights,  and the successive licensors  have only  limited
* liability. 
*
* In this respect, the user's attention is drawn to the risks associated
* with loading,  using,  modifying and/or developing or reproducing the
* software by the user in light of its specific status of free software,
* that may mean  that it is complicated to manipulate,  and  that  also
* therefore means  that it is reserved for developers  and  experienced
* professionals having in-depth computer knowledge. Users are therefore
* encouraged to load and test the software's suitability as regards their
* requirements in conditions enabling the security of their systems and/or 
* data to be ensured and,  more generally, to use and operate it in the 
* same conditions as regards security. 
*
* The fact that you are presently reading this means that you have had
* knowledge of the CeCILL version 2 license and that you accept its terms.
*/

/*! \file vector.c
 * \brief vector functions
 */

#include "vector.h"

/*! \brief return the norm of a vector */
GLfloat vec_get_norm(vec_t *vec)
{
	return (GLfloat)sqrt( (vec->x*vec->x) + (vec->y*vec->y) + (vec->z*vec->z) );
}

/*! \brief normalize a vector */
void vec_normalize(vec_t *vec)
{
	GLfloat norm = vec_get_norm(vec);

	vec->x = vec->x / norm;
	vec->y = vec->y / norm;
	vec->z = vec->z / norm;
	
	/*return vec;*/
}

/*! \brief return the cross product of two vectors */
vec_t vec_cp(vec_t *vec1, vec_t *vec2)
{
	vec_t vec;

	vec.x = ((vec1->y * vec2->z) - (vec1->z * vec2->y));
	vec.y = ((vec1->z * vec2->x) - (vec1->x * vec2->z));
	vec.z = ((vec1->x * vec2->y) - (vec1->y * vec2->x));

	return vec;
}

/*! \brief return the dot product of two vectors */
GLfloat vec_dotprod(vec_t *vec1, vec_t *vec2)
{
	return (vec1->x*vec2->x)+(vec1->y*vec2->y)+(vec1->z*vec2->z);
}
